from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFDefault.File import File
#from OFS.Image import File
from DateTime import DateTime

#from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore import CMFCorePermissions
#from Products.CMFCore.PortalContent import PortalContent

factory_type_information = (
    {'id': 'FlashMovie',
     'content_icon': 'flashmovie_icon.gif',
     'meta_type': 'CMF FlashMovie',
     'description': 'a simple FlashMovie product for CMF',
     'product': 'CMFFlashMovie',
     'factory': 'addFlashMovie',
     'immediate_view': 'flashmovie_view',
     'actions': (                 { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : 'flashmovie_view'
                                  , 'permissions'   : (
                                      CMFCorePermissions.View, )
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'flashmovie_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                                , { 'id'            : 'metadata'
                                  , 'name'          : 'Metadata'
                                  , 'action'        : 'metadata_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                                )
     },
   )

import OFS.Image

def addFlashMovie(self
        , id
        , title=''
        , file=''
        , content_type='application/x-shockwave-flash'
        , precondition=()
        , subject=()
        , description=''
        , contributors=()
        , effective_date=None
        , expiration_date=None
        , format='application/x-shockwave-flash'
        , language=''
        , rights=''):
    """object manager constructor"""
    id, title = OFS.Image.cookId(id, title, file)
    self = self.this()

    o = FlashMovie(id, title, '', content_type, precondition, subject
               , description, contributors, effective_date, expiration_date
               , format, language, rights
               )
    self._setObject(id, o)
    if file:
        self._getOb(id).manage_upload(file)

class FlashMovie(File):

    meta_type = 'CMF FlashMovie'
    
    security = ClassSecurityInfo()
    security.declareObjectProtected(CMFCorePermissions.View)
    _properties = (
        {'id':'title', 	'type':'string', 'mode':'w'},
        {'id':'description', 'type':'text', 'mode':'w'},
        {'id':'width', 	'type':'int', 'mode':'w'},
        {'id':'height', 'type':'int', 'mode':'w'},
        
        {'id':'play',          'type':'boolean', 'mode':'w'},
        {'id':'menu', 	       'type':'boolean', 'mode':'w'},
        {'id':'loop', 	       'type':'boolean', 'mode':'w'},
        {'id':'devicefont',    'type':'boolean', 'mode':'w'},
        {'id':'swliveconnect', 'type':'boolean', 'mode':'w'},
        
        {'id':'quality', 'type':'selection', 'select_variable' : 'getQuality','mode':'w'},
        {'id':'wmode', 	 'type':'selection', 'select_variable' : 'getWmode','mode':'w'},
        {'id':'align', 	 'type':'selection', 'select_variable' : 'getAlign','mode':'w'},
        {'id':'scale', 	 'type':'selection', 'select_variable' : 'getScale','mode':'w'},
        {'id':'salign',  'type':'selection', 'select_variable' : 'getSAlign','mode':'w'},
            
        {'id':'bgcolor', 'type':'string', 'mode':'w'},
        {'id':'base',    'type':'string', 'mode':'w'},
        {'id':'allowscriptaccess',  'type':'selection', 'select_variable' : 'getAllowScriptAccess','mode':'w'},
    )
    __implements__ = (File.__implements__
                     ,
                     )
   
    def __init__(self
                , id
                , title=''
                , file=''
                , content_type=''
                , precondition=''
                , subject=()
                , description=''
                , contributors=()
                , effective_date=None
                , expiration_date=None
                , format='application/x-shockwave-flash'
                , language='en-US'
                , rights=''
                ):
        File.__init__(self, id, title, file, content_type, precondition
                    , subject, description
                    , contributors, effective_date
                    , expiration_date, format, language, rights=''
                    )
        self.width = 0
        self.height = 0
        self.swliveconnect = 0 #FlashMovie.getDefaultSwliveconnect
        self.play = 1 #FlashMovie.getDefaultPlay
        self.loop = 1 #FlashMovie.getDefaultLoop
        self.devicefont = 0 #FlashMovie.getDefaultDevicefont
        self.quality = FlashMovie.getDefaultQuality
        self.bgcolor = FlashMovie.getDefaultBgcolor
        self.scale = FlashMovie.getDefaultScale
        self.align = FlashMovie.getDefaultAlign
        self.salign = FlashMovie.getDefaultSAlign
        self.base = FlashMovie.getDefaultBase
        self.menu = 1 #FlashMovie.getDefaultMenu
        self.wmode = FlashMovie.getDefaultWMode
        self.allowscriptaccess = FlashMovie.getDefaultAllowScriptAccess
        self.preview_image = ''
        self.use_fscommand = 0
        self.fscommand_code=''
        
    def __call__(self):
        """Override File's __call__ method """
        return self.index_html()
	
    security.declareProtected(CMFCorePermissions.View, 'index_html')
    def index_html(self):
       """ Override File's index_html which just returns file data """
       action = self.getTypeInfo().getActionById('view')
       request=self.REQUEST
       response=request.RESPONSE
       response.redirect(self.absolute_url()+'/'+action)

    security.declareProtected(CMFCorePermissions.View, 'view_swf')
    def view_swf(self, REQUEST, RESPONSE):
        """ download the file """
        return OFS.Image.File.index_html(self, REQUEST, RESPONSE)

    security.declareProtected(CMFCorePermissions.View, 'preview')
    def preview(self,REQUEST,RESPONSE):
        """ returns the preview image data (if exists) """
        if self.preview_image:
            return self.preview_image.index_html(REQUEST,RESPONSE)
        
    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'edit')
    def edit(self, precondition='', file='', title='', description='', width=0, height=0, 
                   swliveconnect=0, play=1, loop=1, devicefont=0, quality='high', bgcolor='',
                   scale='swowall', align='', salign='',base='', menu=1, wmode='windowed', allowscriptaccess='samedomain',
                   preview='', use_fscommand=0, fscommand_code=''):
        """ Update and reindex. """

        self.setTitle(title)
        self.setDescription(description)
        self.width = width
        self.height = height
        self.swliveconnect = swliveconnect
        self.play = play
        self.loop = loop
        self.devicefont = devicefont
        self.quality = quality
        self.bgcolor = bgcolor
        self.scale = scale
        self.align = align
        self.salign = salign
        self.base = base
        self.menu = menu
        self.wmode = wmode
        self.allowscriptaccess = allowscriptaccess
        self.reindexObject()
        self.use_fscommand = use_fscommand
        self.fscommand_code=fscommand_code

        self._edit(precondition, file)
        if preview:
            if hasattr(self,'preview_image'):
                img=self.preview_image
                img.manage_upload(preview)
            else:
                self.preview_image=OFS.Image.Image('preview_image','title',preview)
        #if precondition: self.precondition = precondition
        #elif self.precondition: del self.precondition
        #self.manage_upload(file)
        #self.setFormat(self.content_type)

    def manage_upload(self,file='',REQUEST=None):
        """
        Upload an SWF file 
        """
        
        if self.wl_isLocked():
            raise ResourceLockedError, "File is locked via WebDAV"

        data, size = self._read_data(file)
        	
        self.update_data(data, self.content_type, size)

        file.seek(0)
        data=file.read()
        filesize=len(data)
        
        from swfHeaderData import analyseContent

        analysed=analyseContent(data,filesize)

        self.height=analysed['height']
        self.width=analysed['width']
        self.version=analysed['flashversion']
        self.compressed=analysed['compressed']
        self.uncompressed_size=analysed['uncompressed_size']
        self.frame_rate = analysed['frame_rate']
        self.frames_total = analysed['frames_total']
        self.content_type="application/x-shockwave-flash"
        if REQUEST:
            return self.manage_edit(self,REQUEST)

    security.declareProtected(CMFCorePermissions.View, 'fscommand_javascript')
    def fscommand_javascript(self):
        myId = 'FlashMovie'
        s = """
<script language="JavaScript">
<!--
var isInternetExplorer = navigator.appName.indexOf("Microsoft") != -1;
function FlashMovie_DoFSCommand(command, args) {
	var obj = document.all.FlashMovie;
    %s
}
function FlashMovie_embed_DoFSCommand(command, args) {
	var obj = document.FlashMovie_embed;
    %s
}
// Hook for Internet Explorer.
if (navigator.appName && navigator.appName.indexOf("Microsoft") != -1 && navigator.userAgent.indexOf("Windows") != -1 && navigator.userAgent.indexOf("Windows 3.1") == -1) {
	document.write('<script language=\"VBScript\"\>\\n');
	document.write('On Error Resume Next\\n');
	document.write('Sub FlashMovie_FSCommand(ByVal command, ByVal args)\\n');
	document.write('	Call FlashMovie_DoFSCommand(command, args)\\n');
	document.write('End Sub\\n');
	document.write('</script\>\\n');
}
//-->
</script>
""" % (self.fscommand_code, self.fscommand_code)
        return s

    #properties and values
    getQuality = ['low','autolow','autohigh','medium','high','best']
    getScale = ['showall','noborder','exactfit','noscale']
    getAlign = ['','l','r','t','b']
    getWmode = ['window','opaque','transparent']
    getAllowScriptAccess = ['always','never','samedomain']
    getSAlign = ['','l','lt','t','rt','r','rb','b','lb']
    
    getDefaultSwliveconnect = 'false'
    getDefaultPlay = 'true'
    getDefaultLoop = 'true'
    getDefaultDevicefont = 'false'
    getDefaultQuality = 'high'
    getDefaultBgcolor = ''
    getDefaultScale = 'showall'
    getDefaultAlign = ''
    getDefaultSAlign  = ''
    getDefaultBase = ''
    getDefaultMenu = 'true'
    getDefaultWMode = 'window'
    getDefaultAllowScriptAccess = 'samedomain'
    
    getQualityValues = [{'value':'low', 'label':'Low', }, 
             {'value':'autolow','label':'AutoLow',},
             {'value':'autohigh', 'label':'AutoHigh',},
             {'value':'medium', 'label':'Medium',}, 
             {'value':'high', 'label':'High',},
             {'value':'best', 'label':'Best',}
            ] 

    getScaleValues = [{'value':'showall', 'label':'Default (Show all)', }, 
             {'value':'noborder','label':'No border',},
             {'value':'exactfit', 'label':'Exact fit',},
             {'value':'noscale', 'label':'No scale',}, 
            ] 
      
    getHTMLAlignmentValues = [{'value':'', 'label':'Default', },
             {'value':'l', 'label':'Left', }, 
             {'value':'t','label':'Top',},
             {'value':'r', 'label':'Right',},
             {'value':'b', 'label':'Bottom',},             
            ]      
        
    getWindowModeValues = [{'value':'window', 'label':'Window', }, 
             {'value':'opaque','label':'Opaque Windowless',},
             {'value':'transparent', 'label':'Transparent Windowless',},
            ] 

    getAllowScriptAccessValues = [{'value':'always', 'label':'Always', }, 
             {'value':'never','label':'Never',},
             {'value':'samedomain', 'label':'Same Domain',},
            ] 

InitializeClass(FlashMovie)
        

